import React, { ReactEventHandler } from 'react';
import { UseMutationOptions } from '@tanstack/react-query';
import { MutationMode, RaRecord, DeleteParams, RedirectionSideEffect } from 'ra-core';
import { ButtonProps } from './Button';
export declare const DeleteWithConfirmButton: <RecordType extends RaRecord<import("ra-core").Identifier> = any>(props: DeleteWithConfirmButtonProps<RecordType, unknown>) => React.JSX.Element;
export interface DeleteWithConfirmButtonProps<RecordType extends RaRecord = any, MutationOptionsError = unknown> extends ButtonProps {
    confirmTitle?: React.ReactNode;
    confirmContent?: React.ReactNode;
    icon?: React.ReactNode;
    confirmColor?: 'primary' | 'warning';
    mutationMode?: MutationMode;
    onClick?: ReactEventHandler<any>;
    /**
     * @deprecated use `titleTranslateOptions` and `contentTranslateOptions` instead
     */
    translateOptions?: object;
    titleTranslateOptions?: object;
    contentTranslateOptions?: object;
    mutationOptions?: UseMutationOptions<RecordType, MutationOptionsError, DeleteParams<RecordType>>;
    record?: RecordType;
    redirect?: RedirectionSideEffect;
    resource?: string;
    successMessage?: string;
}
//# sourceMappingURL=DeleteWithConfirmButton.d.ts.map