"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeleteWithConfirmButton = void 0;
var react_1 = __importStar(require("react"));
var Delete_1 = __importDefault(require("@mui/icons-material/Delete"));
var clsx_1 = __importDefault(require("clsx"));
var ra_core_1 = require("ra-core");
var layout_1 = require("../layout");
var Button_1 = require("./Button");
var inflection_1 = require("inflection");
var DeleteWithConfirmButton = function (props) {
    var className = props.className, confirmTitleProp = props.confirmTitle, confirmContentProp = props.confirmContent, _a = props.confirmColor, confirmColor = _a === void 0 ? 'primary' : _a, _b = props.icon, icon = _b === void 0 ? defaultIcon : _b, _c = props.label, label = _c === void 0 ? 'ra.action.delete' : _c, _d = props.mutationMode, mutationMode = _d === void 0 ? 'pessimistic' : _d, onClick = props.onClick, _e = props.redirect, redirect = _e === void 0 ? 'list' : _e, _f = props.translateOptions, translateOptions = _f === void 0 ? {} : _f, _g = props.titleTranslateOptions, titleTranslateOptions = _g === void 0 ? translateOptions : _g, _h = props.contentTranslateOptions, contentTranslateOptions = _h === void 0 ? translateOptions : _h, mutationOptions = props.mutationOptions, _j = props.color, color = _j === void 0 ? 'error' : _j, successMessage = props.successMessage, rest = __rest(props, ["className", "confirmTitle", "confirmContent", "confirmColor", "icon", "label", "mutationMode", "onClick", "redirect", "translateOptions", "titleTranslateOptions", "contentTranslateOptions", "mutationOptions", "color", "successMessage"]);
    var translate = (0, ra_core_1.useTranslate)();
    var record = (0, ra_core_1.useRecordContext)(props);
    var resource = (0, ra_core_1.useResourceContext)(props);
    var _k = (0, ra_core_1.useDeleteWithConfirmController)({
        record: record,
        redirect: redirect,
        mutationMode: mutationMode,
        onClick: onClick,
        mutationOptions: mutationOptions,
        resource: resource,
        successMessage: successMessage,
    }), open = _k.open, isPending = _k.isPending, handleDialogOpen = _k.handleDialogOpen, handleDialogClose = _k.handleDialogClose, handleDelete = _k.handleDelete;
    var getRecordRepresentation = (0, ra_core_1.useGetRecordRepresentation)(resource);
    var recordRepresentation = getRecordRepresentation(record);
    var confirmTitle = "resources.".concat(resource, ".message.delete_title");
    var confirmContent = "resources.".concat(resource, ".message.delete_content");
    var resourceName = translate("resources.".concat(resource, ".forcedCaseName"), {
        smart_count: 1,
        _: (0, inflection_1.humanize)(translate("resources.".concat(resource, ".name"), {
            smart_count: 1,
            _: resource ? (0, inflection_1.singularize)(resource) : undefined,
        }), true),
    });
    // We don't support React elements for this
    if ((0, react_1.isValidElement)(recordRepresentation)) {
        recordRepresentation = "#".concat(record === null || record === void 0 ? void 0 : record.id);
    }
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(Button_1.Button, __assign({ onClick: handleDialogOpen, label: label, className: (0, clsx_1.default)('ra-delete-button', className), key: "button", color: color }, rest), icon),
        react_1.default.createElement(layout_1.Confirm, { isOpen: open, loading: isPending, title: confirmTitleProp !== null && confirmTitleProp !== void 0 ? confirmTitleProp : confirmTitle, content: confirmContentProp !== null && confirmContentProp !== void 0 ? confirmContentProp : confirmContent, confirmColor: confirmColor, titleTranslateOptions: __assign({ recordRepresentation: recordRepresentation, name: resourceName, id: record === null || record === void 0 ? void 0 : record.id, _: confirmTitleProp !== null && confirmTitleProp !== void 0 ? confirmTitleProp : translate('ra.message.delete_title', {
                    recordRepresentation: recordRepresentation,
                    name: resourceName,
                    id: record === null || record === void 0 ? void 0 : record.id,
                }) }, titleTranslateOptions), contentTranslateOptions: __assign({ recordRepresentation: recordRepresentation, name: resourceName, id: record === null || record === void 0 ? void 0 : record.id, _: confirmContentProp !== null && confirmContentProp !== void 0 ? confirmContentProp : translate('ra.message.delete_content', {
                    recordRepresentation: recordRepresentation,
                    name: resourceName,
                    id: record === null || record === void 0 ? void 0 : record.id,
                }) }, contentTranslateOptions), onConfirm: handleDelete, onClose: handleDialogClose })));
};
exports.DeleteWithConfirmButton = DeleteWithConfirmButton;
var defaultIcon = react_1.default.createElement(Delete_1.default, null);
//# sourceMappingURL=DeleteWithConfirmButton.js.map