import * as React from 'react';
import { type ComponentsOverrides, type SxProps, type Theme } from '@mui/material/styles';
/**
 * An input placeholder with a loading indicator
 *
 * Avoids visual jumps when replaced by a form input
 */
export declare const LoadingInput: (inProps: LoadingInputProps) => React.JSX.Element;
export interface LoadingInputProps {
    fullWidth?: boolean;
    helperText?: React.ReactNode;
    margin?: 'normal' | 'none' | 'dense';
    label?: string | React.ReactElement | false;
    sx?: SxProps<Theme>;
    size?: 'medium' | 'small';
    timeout?: number;
    variant?: 'standard' | 'filled' | 'outlined';
}
declare module '@mui/material/styles' {
    interface ComponentNameToClassKey {
        RaLoadingInput: 'root';
    }
    interface ComponentsPropsList {
        RaLoadingInput: Partial<LoadingInputProps>;
    }
    interface Components {
        RaLoadingInput?: {
            defaultProps?: ComponentsPropsList['RaLoadingInput'];
            styleOverrides?: ComponentsOverrides<Omit<Theme, 'components'>>['RaLoadingInput'];
        };
    }
}
//# sourceMappingURL=LoadingInput.d.ts.map