"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColumnsSelector = void 0;
var React = __importStar(require("react"));
var react_1 = require("react");
var react_dom_1 = require("react-dom");
var ra_core_1 = require("ra-core");
var material_1 = require("@mui/material");
var button_1 = require("../../button");
/**
 * Render DataTable.Col elements in the ColumnsButton selector using a React Portal.
 *
 * @see ColumnsButton
 */
var ColumnsSelector = function (_a) {
    var children = _a.children;
    var _b = (0, ra_core_1.useDataTableStoreContext)(), storeKey = _b.storeKey, defaultHiddenColumns = _b.defaultHiddenColumns;
    var _c = (0, ra_core_1.useStore)("".concat(storeKey, "_columnRanks")), columnRanks = _c[0], setColumnRanks = _c[1];
    var _d = (0, ra_core_1.useStore)(storeKey, defaultHiddenColumns), _hiddenColumns = _d[0], setHiddenColumns = _d[1];
    var elementId = "".concat(storeKey, "-columnsSelector");
    var _e = React.useState(function () {
        return typeof document !== 'undefined'
            ? document.getElementById(elementId)
            : null;
    }), container = _e[0], setContainer = _e[1];
    // on first mount, we don't have the container yet, so we wait for it
    React.useEffect(function () {
        if (container &&
            typeof document !== 'undefined' &&
            document.body.contains(container))
            return;
        // look for the container in the DOM every 100ms
        var interval = setInterval(function () {
            var target = document.getElementById(elementId);
            if (target)
                setContainer(target);
        }, 100);
        // stop looking after 500ms
        var timeout = setTimeout(function () { return clearInterval(interval); }, 500);
        return function () {
            clearInterval(interval);
            clearTimeout(timeout);
        };
    }, [elementId, container]);
    if (!container)
        return null;
    var childrenArray = react_1.Children.toArray(children);
    var paddedColumnRanks = padRanks(columnRanks !== null && columnRanks !== void 0 ? columnRanks : [], childrenArray.length);
    return (0, react_dom_1.createPortal)(React.createElement(React.Fragment, null,
        paddedColumnRanks.map(function (position, index) { return (React.createElement(ra_core_1.DataTableColumnRankContext.Provider, { value: position, key: index }, childrenArray[position])); }),
        React.createElement(material_1.Box, { component: "li", className: "columns-selector-actions", sx: { textAlign: 'center', mt: 1 } },
            React.createElement(button_1.Button, { onClick: function () {
                    setColumnRanks(undefined);
                    setHiddenColumns(defaultHiddenColumns);
                } }, "Reset"))), container);
};
exports.ColumnsSelector = ColumnsSelector;
var padRanks = function (ranks, length) {
    return ranks.concat(Array.from({ length: length - ranks.length }, function (_, i) { return ranks.length + i; }));
};
//# sourceMappingURL=ColumnsSelector.js.map