"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataTableBody = void 0;
var React = __importStar(require("react"));
var ra_core_1 = require("ra-core");
var material_1 = require("@mui/material");
var styles_1 = require("@mui/material/styles");
var clsx_1 = __importDefault(require("clsx"));
var DataTableRoot_1 = require("./DataTableRoot");
var DataTableRow_1 = require("./DataTableRow");
var DataTableRowSxContext_1 = require("./DataTableRowSxContext");
var PREFIX = 'RaDataTableBody';
exports.DataTableBody = React.memo(React.forwardRef(function (inProps, ref) {
    var props = (0, material_1.useThemeProps)({
        props: inProps,
        name: PREFIX,
    });
    var children = props.children, _a = props.row, TableRow = _a === void 0 ? DataTableRow_1.DataTableRow : _a, className = props.className, rest = __rest(props, ["children", "row", "className"]);
    var data = (0, ra_core_1.useDataTableDataContext)();
    var rowSx = (0, DataTableRowSxContext_1.useDataTableRowSxContext)();
    return (React.createElement(TableBodyStyled, __assign({ ref: ref, className: (0, clsx_1.default)('datatable-body', className, DataTableRoot_1.DataTableClasses.tbody) }, rest), data === null || data === void 0 ? void 0 : data.map(function (record, rowIndex) {
        var _a;
        var _b;
        return (React.createElement(ra_core_1.RecordContextProvider, { value: record, key: (_b = record.id) !== null && _b !== void 0 ? _b : "row".concat(rowIndex) },
            React.createElement(TableRow, { className: (0, clsx_1.default)(DataTableRoot_1.DataTableClasses.row, (_a = {},
                    _a[DataTableRoot_1.DataTableClasses.rowEven] = rowIndex % 2 === 0,
                    _a[DataTableRoot_1.DataTableClasses.rowOdd] = rowIndex % 2 !== 0,
                    _a)), sx: rowSx === null || rowSx === void 0 ? void 0 : rowSx(record, rowIndex) }, children)));
    })));
}));
exports.DataTableBody.displayName = 'DataTableBody';
var TableBodyStyled = (0, styles_1.styled)(material_1.TableBody, {
    name: PREFIX,
    overridesResolver: function (props, styles) { return styles.root; },
})(function () { return ({}); });
//# sourceMappingURL=DataTableBody.js.map