"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataTableCell = void 0;
var React = __importStar(require("react"));
var ra_core_1 = require("ra-core");
var material_1 = require("@mui/material");
var styles_1 = require("@mui/material/styles");
var get_1 = __importDefault(require("lodash/get"));
var clsx_1 = __importDefault(require("clsx"));
var PREFIX = 'RaDataTableCell';
exports.DataTableCell = React.memo(React.forwardRef(function (inProps, ref) {
    var props = (0, material_1.useThemeProps)({
        props: inProps,
        name: PREFIX,
    });
    var cellSx = props.cellSx, cellClassName = props.cellClassName, headerClassName = props.headerClassName, children = props.children, className = props.className, disableSort = props.disableSort, render = props.render, field = props.field, source = props.source, sortByOrder = props.sortByOrder, label = props.label, sx = props.sx, rest = __rest(props, ["cellSx", "cellClassName", "headerClassName", "children", "className", "disableSort", "render", "field", "source", "sortByOrder", "label", "sx"]);
    var _a = (0, ra_core_1.useDataTableStoreContext)(), storeKey = _a.storeKey, defaultHiddenColumns = _a.defaultHiddenColumns;
    var hiddenColumns = (0, ra_core_1.useStore)(storeKey, defaultHiddenColumns)[0];
    var record = (0, ra_core_1.useRecordContext)();
    var isColumnHidden = hiddenColumns.includes(source);
    if (isColumnHidden)
        return null;
    if (!render && !field && !children && !source) {
        throw new Error('Missing at least one of the following props: render, field, children, or source');
    }
    var sxValue = __assign(__assign({}, (cellSx && record ? cellSx(record) : {})), sx);
    return (React.createElement(TableCellStyled, __assign({ ref: ref, className: (0, clsx_1.default)(className, cellClassName, "column-".concat(source)), sx: sxValue }, rest), children !== null && children !== void 0 ? children : (render
        ? record && render(record)
        : field
            ? React.createElement(field, { source: source })
            : (0, get_1.default)(record, source))));
}));
exports.DataTableCell.displayName = 'DataTableCell';
var TableCellStyled = (0, styles_1.styled)(material_1.TableCell, {
    name: PREFIX,
    overridesResolver: function (props, styles) { return styles.root; },
})(function () { return ({}); });
//# sourceMappingURL=DataTableCell.js.map