"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataTableHead = void 0;
var React = __importStar(require("react"));
var react_1 = require("react");
var material_1 = require("@mui/material");
var styles_1 = require("@mui/material/styles");
var clsx_1 = __importDefault(require("clsx"));
var ra_core_1 = require("ra-core");
var ExpandAllButton_1 = __importDefault(require("../datagrid/ExpandAllButton"));
var SelectPageCheckbox_1 = require("./SelectPageCheckbox");
var DataTableRoot_1 = require("./DataTableRoot");
/**
 * The default DataTable Head component.
 *
 * Renders select all checkbox as well as column head buttons used for sorting.
 */
exports.DataTableHead = (0, react_1.memo)(function (inProps) {
    var props = (0, styles_1.useThemeProps)({
        props: inProps,
        name: PREFIX,
    });
    var children = props.children, className = props.className, sx = props.sx;
    var _a = (0, ra_core_1.useDataTableConfigContext)(), expand = _a.expand, expandSingle = _a.expandSingle, _b = _a.hasBulkActions, hasBulkActions = _b === void 0 ? false : _b;
    var data = (0, ra_core_1.useDataTableDataContext)();
    var handleToggleItem = (0, ra_core_1.useDataTableCallbacksContext)().handleToggleItem;
    var hasExpand = !!expand;
    return (React.createElement(TableHeadStyled, { className: (0, clsx_1.default)(className, DataTableRoot_1.DataTableClasses.thead), sx: sx },
        React.createElement(material_1.TableRow, { className: (0, clsx_1.default)(DataTableRoot_1.DataTableClasses.row, DataTableRoot_1.DataTableClasses.headerRow) },
            hasExpand && (React.createElement(material_1.TableCell, { padding: "none", variant: "head", className: (0, clsx_1.default)(DataTableRoot_1.DataTableClasses.headerCell, DataTableRoot_1.DataTableClasses.expandHeader) }, !expandSingle && data ? (React.createElement(ExpandAllButton_1.default, { classes: DataTableRoot_1.DataTableClasses, ids: data.map(function (record) { return record.id; }) })) : null)),
            hasBulkActions && handleToggleItem && (React.createElement(material_1.TableCell, { padding: "checkbox", variant: "head", className: DataTableRoot_1.DataTableClasses.headerCell },
                React.createElement(SelectPageCheckbox_1.SelectPageCheckbox, null))),
            children)));
});
exports.DataTableHead.displayName = 'DataTableHead';
var PREFIX = 'RaDataTableHead';
var TableHeadStyled = (0, styles_1.styled)(material_1.TableHead, {
    name: PREFIX,
    overridesResolver: function (props, styles) { return styles.root; },
})(function () { return ({}); });
//# sourceMappingURL=DataTableHead.js.map