"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataTableLoading = void 0;
var React = __importStar(require("react"));
var react_1 = require("react");
var material_1 = require("@mui/material");
var ExpandMore_1 = __importDefault(require("@mui/icons-material/ExpandMore"));
var clsx_1 = __importDefault(require("clsx"));
var ra_core_1 = require("ra-core");
var DataTableRoot_1 = require("./DataTableRoot");
var Placeholder_1 = require("../Placeholder");
var times = function (nbChildren, fn) {
    return Array.from({ length: nbChildren }, function (_, key) { return fn(key); });
};
exports.DataTableLoading = (0, react_1.memo)(function DataTableLoading(_a) {
    var className = _a.className, expand = _a.expand, hasBulkActions = _a.hasBulkActions, nbChildren = _a.nbChildren, _b = _a.nbFakeLines, nbFakeLines = _b === void 0 ? 5 : _b, size = _a.size;
    var oneSecondHasPassed = (0, ra_core_1.useTimeout)(1000);
    if (!oneSecondHasPassed)
        return null;
    return (React.createElement("div", { className: DataTableRoot_1.DataTableClasses.root },
        React.createElement(material_1.Table, { className: (0, clsx_1.default)(DataTableRoot_1.DataTableClasses.table, className), size: size },
            React.createElement(material_1.TableHead, null,
                React.createElement(material_1.TableRow, { className: DataTableRoot_1.DataTableClasses.row },
                    expand && (React.createElement(material_1.TableCell, { padding: "none", className: DataTableRoot_1.DataTableClasses.expandHeader })),
                    hasBulkActions && (React.createElement(material_1.TableCell, { padding: "checkbox", className: DataTableRoot_1.DataTableClasses.expandIconCell },
                        React.createElement(material_1.Checkbox, { className: "select-all", color: "primary", checked: false }))),
                    times(nbChildren, function (key) { return (React.createElement(material_1.TableCell, { variant: "head", className: DataTableRoot_1.DataTableClasses.headerCell, key: key },
                        React.createElement(Placeholder_1.Placeholder, null))); }))),
            React.createElement(material_1.TableBody, null, times(nbFakeLines, function (key1) { return (React.createElement(material_1.TableRow, { key: key1, style: { opacity: 1 / (key1 + 1) } },
                expand && (React.createElement(material_1.TableCell, { padding: "none", className: DataTableRoot_1.DataTableClasses.expandIconCell },
                    React.createElement(material_1.IconButton, { className: DataTableRoot_1.DataTableClasses.expandIcon, component: "div", "aria-hidden": "true", size: "large" },
                        React.createElement(ExpandMore_1.default, null)))),
                hasBulkActions && (React.createElement(material_1.TableCell, { padding: "checkbox", className: DataTableRoot_1.DataTableClasses.expandIconCell },
                    React.createElement(material_1.Checkbox, { className: "select-all", color: "primary", checked: false }))),
                times(nbChildren, function (key2) { return (React.createElement(material_1.TableCell, { className: DataTableRoot_1.DataTableClasses.rowCell, key: key2 },
                    React.createElement(Placeholder_1.Placeholder, null))); }))); })))));
});
//# sourceMappingURL=DataTableLoading.js.map