import * as React from 'react';
import { type ExtractRecordPaths, type HintedString } from 'ra-core';
import { type DataTableColumnProps } from './DataTableColumn';
type NoInfer<T> = T extends infer U ? U : never;
export interface DataTableNumberColumnProps<RecordType extends Record<string, any> = Record<string, any>> extends DataTableColumnProps<RecordType> {
    source: NoInfer<HintedString<ExtractRecordPaths<RecordType>>>;
    locales?: string | string[];
    options?: Intl.NumberFormatOptions;
}
export declare const DataTableNumberColumn: <RecordType extends Record<string, any> = Record<string, any>>(props: DataTableNumberColumnProps<RecordType>) => React.JSX.Element;
export {};
//# sourceMappingURL=DataTableNumberColumn.d.ts.map