"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterFormClasses = exports.FilterFormBase = exports.FilterForm = void 0;
var styles_1 = require("@mui/material/styles");
var get_1 = __importDefault(require("lodash/get"));
var ra_core_1 = require("ra-core");
var React = __importStar(require("react"));
var react_1 = require("react");
var FilterContext_1 = require("../FilterContext");
var FilterFormInput_1 = require("./FilterFormInput");
var FilterForm = function (inProps) {
    var props = (0, styles_1.useThemeProps)({
        props: inProps,
        name: PREFIX,
    });
    var filtersProps = props.filters, rest = __rest(props, ["filters"]);
    var filters = (0, react_1.useContext)(FilterContext_1.FilterContext) || filtersProps;
    return (React.createElement(ra_core_1.FilterLiveForm, __assign({ formComponent: StyledForm }, sanitizeRestProps(rest)),
        React.createElement(exports.FilterFormBase, { filters: filters })));
};
exports.FilterForm = FilterForm;
var FilterFormBase = function (props) {
    var filters = props.filters;
    var resource = (0, ra_core_1.useResourceContext)(props);
    var _a = (0, ra_core_1.useListContext)(), _b = _a.displayedFilters, displayedFilters = _b === void 0 ? {} : _b, filterValues = _a.filterValues, hideFilter = _a.hideFilter;
    (0, react_1.useEffect)(function () {
        if (!filters)
            return;
        filters.forEach(function (filter) {
            if (filter.props.alwaysOn && filter.props.defaultValue) {
                throw new Error('Cannot use alwaysOn and defaultValue on a filter input. Please set the filterDefaultValues props on the <List> element instead.');
            }
        });
    }, [filters]);
    var getShownFilters = function () {
        if (!filters)
            return [];
        var values = filterValues;
        return filters.filter(function (filterElement) {
            var filterValue = (0, get_1.default)(values, filterElement.props.source);
            return (filterElement.props.alwaysOn ||
                displayedFilters[filterElement.props.source] ||
                !isEmptyValue(filterValue));
        });
    };
    var handleHide = (0, react_1.useCallback)(function (event) { return hideFilter(event.currentTarget.dataset.key); }, [hideFilter]);
    return (React.createElement(React.Fragment, null,
        getShownFilters().map(function (filterElement) { return (React.createElement(FilterFormInput_1.FilterFormInput, { key: filterElement.key || filterElement.props.source, filterElement: filterElement, handleHide: handleHide, resource: resource, className: exports.FilterFormClasses.filterFormInput })); }),
        React.createElement("div", { className: exports.FilterFormClasses.clearFix })));
};
exports.FilterFormBase = FilterFormBase;
var sanitizeRestProps = function (_a) {
    var hasCreate = _a.hasCreate, resource = _a.resource, props = __rest(_a, ["hasCreate", "resource"]);
    return props;
};
var PREFIX = 'RaFilterForm';
exports.FilterFormClasses = {
    clearFix: "".concat(PREFIX, "-clearFix"),
    filterFormInput: "".concat(PREFIX, "-filterFormInput"),
};
var StyledForm = (0, styles_1.styled)('form', {
    name: PREFIX,
    overridesResolver: function (props, styles) { return styles.root; },
})(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            display: 'flex',
            flex: '0 1 auto'
        },
        _b[theme.breakpoints.down('sm')] = {
            width: '100%',
        },
        _b[theme.breakpoints.up('sm')] = {
            minHeight: theme.spacing(8),
        },
        _b[theme.breakpoints.up('md')] = {
            flex: '0 1 100%',
        },
        _b.flexWrap = 'wrap',
        _b.alignItems = 'flex-end',
        _b.pointerEvents = 'none',
        _b.padding = "0 0 ".concat(theme.spacing(0.5), " 0"),
        _b['& .MuiFormHelperText-root'] = { display: 'none' },
        _b["& .".concat(exports.FilterFormClasses.clearFix)] = { clear: 'right' },
        _b["& .".concat(exports.FilterFormClasses.filterFormInput, " .MuiFormControl-root")] = {
            marginTop: "".concat(theme.spacing(1)),
        },
        _b);
});
var isEmptyValue = function (filterValue) {
    if (filterValue === '' || filterValue == null)
        return true;
    // If one of the value leaf is not empty
    // the value is considered not empty
    if (typeof filterValue === 'object') {
        return Object.keys(filterValue).every(function (key) {
            return isEmptyValue(filterValue[key]);
        });
    }
    return false;
};
//# sourceMappingURL=FilterForm.js.map