import * as React from 'react';
import { ArrayFieldProps } from '../field';
export declare const listFieldTypes: {
    table: {
        component: (props: any) => React.JSX.Element;
        representation: (_props: any, children: any) => string;
    };
    array: {
        component: ({ children, ...props }: ArrayFieldProps) => React.JSX.Element;
        representation: (props: any, children: any) => string;
    };
    boolean: {
        component: {
            <RecordType extends Record<string, any> = Record<string, any>>(inProps: import("../field").BooleanFieldProps<RecordType>): React.JSX.Element;
            displayName: string;
        };
        representation: (props: any) => string;
    };
    date: {
        component: {
            <RecordType_1 extends Record<string, any> = Record<string, any>>(props: import("../field").DateFieldProps<RecordType_1>): React.JSX.Element | null;
            displayName: string;
        };
        representation: (props: any) => string;
    };
    email: {
        component: {
            <RecordType_2 extends Record<string, any> = Record<string, any>>(props: import("../field").EmailFieldProps<RecordType_2>): React.JSX.Element | null;
            displayName: string;
        };
        representation: (props: any) => string;
    };
    id: {
        component: {
            <RecordType_3 extends Record<string, any> = Record<string, any>>(props: import("../field").TextFieldProps<RecordType_3>): React.JSX.Element;
            displayName: string;
        };
        representation: (props: any) => string;
    };
    number: {
        component: {
            <RecordType_4 extends Record<string, any> = Record<string, any>>(props: import("../field").NumberFieldProps<RecordType_4>): React.JSX.Element | null;
            displayName: string;
        };
        representation: (props: any) => string;
    };
    reference: {
        component: <RecordType_5 extends Record<string, any> = Record<string, any>, ReferenceRecordType extends import("ra-core").RaRecord<import("ra-core").Identifier> = import("ra-core").RaRecord<import("ra-core").Identifier>>(inProps: import("../field").ReferenceFieldProps<RecordType_5, ReferenceRecordType>) => React.JSX.Element | null;
        representation: (props: any) => string;
    };
    referenceChild: {
        component: () => React.JSX.Element;
        representation: () => string;
    };
    referenceArray: {
        component: <RecordType_6 extends import("ra-core").RaRecord<import("ra-core").Identifier> = import("ra-core").RaRecord<import("ra-core").Identifier>, ReferenceRecordType_1 extends import("ra-core").RaRecord<import("ra-core").Identifier> = import("ra-core").RaRecord<import("ra-core").Identifier>>(inProps: import("../field").ReferenceArrayFieldProps<RecordType_6, ReferenceRecordType_1>) => React.JSX.Element;
        representation: (props: any) => string;
    };
    referenceArrayChild: {
        component: () => React.JSX.Element;
        representation: () => string;
    };
    richText: undefined;
    string: {
        component: {
            <RecordType_3 extends Record<string, any> = Record<string, any>>(props: import("../field").TextFieldProps<RecordType_3>): React.JSX.Element;
            displayName: string;
        };
        representation: (props: any) => string;
    };
    url: {
        component: {
            <RecordType_7 extends Record<string, any> = Record<string, any>>(props: import("../field").UrlFieldProps<RecordType_7>): React.JSX.Element;
            displayName: string;
        };
        representation: (props: any) => string;
    };
};
//# sourceMappingURL=listFieldTypes.d.ts.map