var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { Fragment, isValidElement } from 'react';
import ActionDelete from '@mui/icons-material/Delete';
import clsx from 'clsx';
import { useDeleteWithConfirmController, useRecordContext, useResourceContext, useTranslate, useGetRecordRepresentation, } from 'ra-core';
import { Confirm } from '../layout';
import { Button } from './Button';
import { humanize, singularize } from 'inflection';
export var DeleteWithConfirmButton = function (props) {
    var className = props.className, confirmTitleProp = props.confirmTitle, confirmContentProp = props.confirmContent, _a = props.confirmColor, confirmColor = _a === void 0 ? 'primary' : _a, _b = props.icon, icon = _b === void 0 ? defaultIcon : _b, _c = props.label, label = _c === void 0 ? 'ra.action.delete' : _c, _d = props.mutationMode, mutationMode = _d === void 0 ? 'pessimistic' : _d, onClick = props.onClick, _e = props.redirect, redirect = _e === void 0 ? 'list' : _e, _f = props.translateOptions, translateOptions = _f === void 0 ? {} : _f, _g = props.titleTranslateOptions, titleTranslateOptions = _g === void 0 ? translateOptions : _g, _h = props.contentTranslateOptions, contentTranslateOptions = _h === void 0 ? translateOptions : _h, mutationOptions = props.mutationOptions, _j = props.color, color = _j === void 0 ? 'error' : _j, successMessage = props.successMessage, rest = __rest(props, ["className", "confirmTitle", "confirmContent", "confirmColor", "icon", "label", "mutationMode", "onClick", "redirect", "translateOptions", "titleTranslateOptions", "contentTranslateOptions", "mutationOptions", "color", "successMessage"]);
    var translate = useTranslate();
    var record = useRecordContext(props);
    var resource = useResourceContext(props);
    var _k = useDeleteWithConfirmController({
        record: record,
        redirect: redirect,
        mutationMode: mutationMode,
        onClick: onClick,
        mutationOptions: mutationOptions,
        resource: resource,
        successMessage: successMessage,
    }), open = _k.open, isPending = _k.isPending, handleDialogOpen = _k.handleDialogOpen, handleDialogClose = _k.handleDialogClose, handleDelete = _k.handleDelete;
    var getRecordRepresentation = useGetRecordRepresentation(resource);
    var recordRepresentation = getRecordRepresentation(record);
    var confirmTitle = "resources.".concat(resource, ".message.delete_title");
    var confirmContent = "resources.".concat(resource, ".message.delete_content");
    var resourceName = translate("resources.".concat(resource, ".forcedCaseName"), {
        smart_count: 1,
        _: humanize(translate("resources.".concat(resource, ".name"), {
            smart_count: 1,
            _: resource ? singularize(resource) : undefined,
        }), true),
    });
    // We don't support React elements for this
    if (isValidElement(recordRepresentation)) {
        recordRepresentation = "#".concat(record === null || record === void 0 ? void 0 : record.id);
    }
    return (React.createElement(Fragment, null,
        React.createElement(Button, __assign({ onClick: handleDialogOpen, label: label, className: clsx('ra-delete-button', className), key: "button", color: color }, rest), icon),
        React.createElement(Confirm, { isOpen: open, loading: isPending, title: confirmTitleProp !== null && confirmTitleProp !== void 0 ? confirmTitleProp : confirmTitle, content: confirmContentProp !== null && confirmContentProp !== void 0 ? confirmContentProp : confirmContent, confirmColor: confirmColor, titleTranslateOptions: __assign({ recordRepresentation: recordRepresentation, name: resourceName, id: record === null || record === void 0 ? void 0 : record.id, _: confirmTitleProp !== null && confirmTitleProp !== void 0 ? confirmTitleProp : translate('ra.message.delete_title', {
                    recordRepresentation: recordRepresentation,
                    name: resourceName,
                    id: record === null || record === void 0 ? void 0 : record.id,
                }) }, titleTranslateOptions), contentTranslateOptions: __assign({ recordRepresentation: recordRepresentation, name: resourceName, id: record === null || record === void 0 ? void 0 : record.id, _: confirmContentProp !== null && confirmContentProp !== void 0 ? confirmContentProp : translate('ra.message.delete_content', {
                    recordRepresentation: recordRepresentation,
                    name: resourceName,
                    id: record === null || record === void 0 ? void 0 : record.id,
                }) }, contentTranslateOptions), onConfirm: handleDelete, onClose: handleDialogClose })));
};
var defaultIcon = React.createElement(ActionDelete, null);
//# sourceMappingURL=DeleteWithConfirmButton.js.map