import * as React from 'react';
import { type ComponentsOverrides, type SxProps, type Theme } from '@mui/material/styles';
import { type ExtractRecordPaths, type HintedString } from 'ra-core';
import type { FieldProps } from './types';
export declare const ImageField: {
    <RecordType extends Record<string, any> = Record<string, any>>(inProps: ImageFieldProps<RecordType>): React.JSX.Element;
    displayName: string;
};
export declare const ImageFieldClasses: {
    list: string;
    image: string;
};
export interface ImageFieldProps<RecordType extends Record<string, any> = Record<string, any>> extends FieldProps<RecordType> {
    src?: string;
    title?: HintedString<ExtractRecordPaths<RecordType>>;
    sx?: SxProps<Theme>;
}
declare module '@mui/material/styles' {
    interface ComponentNameToClassKey {
        RaImageField: 'root' | 'list' | 'image';
    }
    interface ComponentsPropsList {
        RaImageField: Partial<ImageFieldProps>;
    }
    interface Components {
        RaImageField?: {
            defaultProps?: ComponentsPropsList['RaImageField'];
            styleOverrides?: ComponentsOverrides<Omit<Theme, 'components'>>['RaImageField'];
        };
    }
}
//# sourceMappingURL=ImageField.d.ts.map