import * as React from 'react';
import { memo } from 'react';
import { Table, TableCell, TableHead, TableRow, TableBody, IconButton, Checkbox, } from '@mui/material';
import ExpandMoreIcon from '@mui/icons-material/ExpandMore';
import clsx from 'clsx';
import { useTimeout } from 'ra-core';
import { DataTableClasses } from './DataTableRoot';
import { Placeholder } from '../Placeholder';
var times = function (nbChildren, fn) {
    return Array.from({ length: nbChildren }, function (_, key) { return fn(key); });
};
export var DataTableLoading = memo(function DataTableLoading(_a) {
    var className = _a.className, expand = _a.expand, hasBulkActions = _a.hasBulkActions, nbChildren = _a.nbChildren, _b = _a.nbFakeLines, nbFakeLines = _b === void 0 ? 5 : _b, size = _a.size;
    var oneSecondHasPassed = useTimeout(1000);
    if (!oneSecondHasPassed)
        return null;
    return (React.createElement("div", { className: DataTableClasses.root },
        React.createElement(Table, { className: clsx(DataTableClasses.table, className), size: size },
            React.createElement(TableHead, null,
                React.createElement(TableRow, { className: DataTableClasses.row },
                    expand && (React.createElement(TableCell, { padding: "none", className: DataTableClasses.expandHeader })),
                    hasBulkActions && (React.createElement(TableCell, { padding: "checkbox", className: DataTableClasses.expandIconCell },
                        React.createElement(Checkbox, { className: "select-all", color: "primary", checked: false }))),
                    times(nbChildren, function (key) { return (React.createElement(TableCell, { variant: "head", className: DataTableClasses.headerCell, key: key },
                        React.createElement(Placeholder, null))); }))),
            React.createElement(TableBody, null, times(nbFakeLines, function (key1) { return (React.createElement(TableRow, { key: key1, style: { opacity: 1 / (key1 + 1) } },
                expand && (React.createElement(TableCell, { padding: "none", className: DataTableClasses.expandIconCell },
                    React.createElement(IconButton, { className: DataTableClasses.expandIcon, component: "div", "aria-hidden": "true", size: "large" },
                        React.createElement(ExpandMoreIcon, null)))),
                hasBulkActions && (React.createElement(TableCell, { padding: "checkbox", className: DataTableClasses.expandIconCell },
                    React.createElement(Checkbox, { className: "select-all", color: "primary", checked: false }))),
                times(nbChildren, function (key2) { return (React.createElement(TableCell, { className: DataTableClasses.rowCell, key: key2 },
                    React.createElement(Placeholder, null))); }))); })))));
});
//# sourceMappingURL=DataTableLoading.js.map